function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

import React from 'react';
import moment from 'moment';
import DatePicker from '../datepicker';

var valueToMoment = function valueToMoment(value, sourceMask) {
  if (!value) {
    return null;
  }

  if (value instanceof Date) {
    return moment(value);
  } else if (moment.isMoment(value)) {
    return value;
  } else if (typeof value === "string" || typeof value === "number") {
    if (!sourceMask) {
      throw new Error("DatePickerAdapter \u6536\u5230 value: '".concat(value, "', type: '").concat(_typeof(value), "'\uFF0C\u4F46\u6CA1\u5199 sourceMask\uFF0C\u8BF7\u68C0\u67E5!"));
    }

    var strValue = String(value);
    var mnt = moment(strValue, sourceMask, true);

    if (!mnt.isValid()) {
      throw new Error("DatePickerAdapter \u6536\u5230 value: '".concat(value, "', type: '").concat(_typeof(value), "'\uFF0C\u4E0E sourceMask: '").concat(sourceMask, "' \u683C\u5F0F\u4E0D\u5339\u914D\uFF0C\u8BF7\u68C0\u67E5!"));
    }

    return mnt;
  }
};

export default function DatePickerAdapter(props) {
  var value = props.value,
      children = props.children,
      onChange = props.onChange,
      sourceMask = props.sourceMask;
  var data = valueToMoment(value, sourceMask);

  var triggerOnChange = function triggerOnChange(date, datestring) {
    if (onChange) {
      onChange(date, datestring);
    }

    if (children.props.onChange) {
      children.props.onChange(date, datestring);
    }
  };

  return /*#__PURE__*/React.createElement(DatePicker, _extends({}, children.props, {
    value: data,
    onChange: triggerOnChange
  }));
}