function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
}; // @ts-nocheck


import { Cascader } from 'antd';
import React, { forwardRef, useContext } from 'react';
import MouseXConfigContext from '../MXConfigProvider/MouseXConfigContext';

var MyCascader = function MyCascader(props, ref) {
  var inputShowTitle = props.inputShowTitle,
      value = props.value,
      defaultValue = props.defaultValue,
      resData = __rest(props, ["inputShowTitle", "value", "defaultValue"]);

  var titleArray = [];

  function getCodeContent(options, value) {
    if (value) {
      options.forEach(function (item) {
        value.forEach(function (m) {
          if (m == item.value) {
            titleArray.push(item.title);
          }
        });

        if (item.children) {
          getCodeContent(item.children, value);
        }
      });
      return titleArray.join('/');
    }
  }

  var contextInputShowTitle = useContext(MouseXConfigContext).inputShowTitle;
  var showTitle;

  if (inputShowTitle != undefined) {
    showTitle = inputShowTitle;
  } else if (inputShowTitle == undefined) {
    if (contextInputShowTitle !== undefined) {
      showTitle = contextInputShowTitle;
    } else if (contextInputShowTitle == undefined) {
      showTitle = false;
    }
  }

  if (showTitle == true) {
    return /*#__PURE__*/React.createElement("div", {
      title: value ? getCodeContent(props.options, value) : defaultValue,
      id: '123'
    }, /*#__PURE__*/React.createElement(Cascader, _extends({
      type: "TextArea",
      ref: ref,
      value: value,
      defaultValue: defaultValue
    }, resData)));
  } else {
    return /*#__PURE__*/React.createElement(Cascader, _extends({
      value: value,
      ref: ref,
      defaultValue: defaultValue
    }, resData));
  }
};

export default /*#__PURE__*/forwardRef(MyCascader);