function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
}; // @ts-nocheck


import { InputNumber } from 'antd';
import React, { forwardRef, useContext } from 'react';
import MouseXConfigContext from '../MXConfigProvider/MouseXConfigContext';

var MyInputNumber = function MyInputNumber(props, ref) {
  var inputShowTitle = props.inputShowTitle,
      value = props.value,
      defaultValue = props.defaultValue,
      inputNumberAutoFillout = props.inputNumberAutoFillout,
      onChange = props.onChange,
      resData = __rest(props, ["inputShowTitle", "value", "defaultValue", "inputNumberAutoFillout", "onChange"]);

  var showTitle, autoFillout;
  var inputNumberValue = value;
  var contextInputShowTitle = useContext(MouseXConfigContext).inputShowTitle;
  var contextInputNumberAutoFillout = useContext(MouseXConfigContext).inputNumberAutoFillout;

  if (inputShowTitle != undefined) {
    showTitle = inputShowTitle;
  } else if (inputShowTitle == undefined) {
    if (contextInputShowTitle !== undefined) {
      showTitle = contextInputShowTitle;
    } else if (contextInputShowTitle == undefined) {
      showTitle = false;
    }
  }

  if (inputNumberAutoFillout != undefined) {
    autoFillout = inputNumberAutoFillout;
  } else if (inputNumberAutoFillout == undefined) {
    if (contextInputNumberAutoFillout !== undefined) {
      autoFillout = contextInputNumberAutoFillout;
    } else if (contextInputNumberAutoFillout == undefined) {
      autoFillout = false;
    }
  }

  var inputBlur = function inputBlur() {
    if (autoFillout == true) {
      if (inputNumberValue == null) {
        inputNumberValue = 0;
        onChange(inputNumberValue);
      }
    }
  };

  if (showTitle == true) {
    return /*#__PURE__*/React.createElement(InputNumber, _extends({
      ref: ref,
      title: value ? value : defaultValue,
      value: inputNumberValue,
      defaultValue: defaultValue,
      onChange: onChange,
      onBlur: autoFillout ? inputBlur : null
    }, resData));
  } else {
    return /*#__PURE__*/React.createElement(InputNumber, _extends({
      ref: ref,
      value: inputNumberValue,
      defaultValue: defaultValue,
      onChange: onChange,
      onBlur: autoFillout ? inputBlur : null
    }, resData));
  }
};

export default /*#__PURE__*/forwardRef(MyInputNumber);