function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
}; // @ts-nocheck


import { Modal } from 'antd';
import { v4 } from 'uuid';
import MouseXConfigContext from '../MXConfigProvider/MouseXConfigContext';
import React, { useContext, useEffect, useState } from 'react';
import './style';
export var destroyFns = [];
export default function myModal(props) {
  var _props$draggable = props.draggable,
      draggable = _props$draggable === void 0 ? false : _props$draggable,
      changeSize = props.changeSize,
      maxWidth = props.maxWidth,
      maxHeight = props.maxHeight,
      title = props.title,
      _props$className = props.className,
      className = _props$className === void 0 ? '' : _props$className,
      rest = __rest(props, ["draggable", "changeSize", "maxWidth", "maxHeight", "title", "className"]);

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      cursorMove = _useState2[0],
      setCursorMove = _useState2[1];

  var modalClassName = v4();
  var mxModalDraggable = useContext(MouseXConfigContext).modalDraggable;
  var mxModalChangeSize = useContext(MouseXConfigContext).modalChangeSize;
  var mxModalMaxWidth = useContext(MouseXConfigContext).modalMaxWidth;
  var mxModalMaxHeight = useContext(MouseXConfigContext).modalMaxHeight;
  var isDialog = className.indexOf('mousex-dialog');
  useEffect(function () {
    var modalDom;

    if (isDialog == -1) {
      modalDom = document.getElementsByClassName(modalClassName)[0];
    }

    var draggableFunction = function draggableFunction() {
      if (modalDom) {
        var headerDom = modalDom.getElementsByClassName('ant-modal-header')[0];
        var startX = 0;
        var startY = 0;

        headerDom.onmousedown = function (event) {
          startX = event.screenX;
          startY = event.screenY;
          setCursorMove(true);
          var contentDom = modalDom.getElementsByClassName('ant-modal-content')[0];
          var contentStartLeft = parseInt(window.getComputedStyle(contentDom)['left']);
          var contentStartTop = parseInt(window.getComputedStyle(contentDom)['top']);
          var mouseLeftMin = parseInt(window.getComputedStyle(headerDom)['paddingLeft']) + event.offsetX;
          var mouseLeftMax = window.innerWidth - contentDom.getBoundingClientRect().width + event.offsetX + parseInt(window.getComputedStyle(headerDom)['paddingLeft']);
          var mouseTopMin = parseInt(window.getComputedStyle(headerDom)['paddingTop']) + event.offsetY;
          var mouseTopMax = window.innerHeight - contentDom.getBoundingClientRect().height + event.offsetY + parseInt(window.getComputedStyle(headerDom)['paddingTop']);

          window.document.onmousemove = function (e) {
            if (mouseLeftMax > e.clientX && e.clientX > mouseLeftMin && e.clientY > mouseTopMin && e.clientY < mouseTopMax) {
              if (contentStartLeft == 0 && contentStartTop == 0) {
                contentDom.style.left = e.screenX - startX + 'px';
                contentDom.style.top = e.screenY - startY - 2 + 'px';
              } else {
                contentDom.style.left = contentStartLeft + e.screenX - startX + 'px';
                contentDom.style.top = contentStartTop + e.screenY - startY + 'px';
              }
            }
          };

          headerDom.onmouseup = function (e2) {
            setCursorMove(false);
            window.document.onmousemove = null;
          };
        };
      }
    };

    if (draggable == true) {
      draggableFunction();
    } else if (draggable == false) {
      if (mxModalDraggable) {
        draggableFunction();
      }
    }
  }, []);

  var _useState3 = useState(null),
      _useState4 = _slicedToArray(_useState3, 2),
      startHeight = _useState4[0],
      setStartHeight = _useState4[1];

  var _useState5 = useState(null),
      _useState6 = _slicedToArray(_useState5, 2),
      startWidth = _useState6[0],
      setStartWidth = _useState6[1];

  var tempModalMaxWidth = maxWidth ? maxWidth : mxModalMaxWidth ? mxModalMaxWidth : 'auto';
  var tempModalMaxHeight = maxHeight ? maxHeight : mxModalMaxHeight ? mxModalMaxHeight : 'auto';

  var fullScreen = function fullScreen(e) {
    var modalDom = document.getElementsByClassName(modalClassName)[0];

    if (modalDom.style.height !== tempModalMaxHeight && modalDom.style.width !== tempModalMaxWidth) {
      if (!modalDom.style.height) {
        var modalHeight = parseInt(window.getComputedStyle(modalDom)['height']);
        setStartHeight(modalHeight);
      } else {
        setStartHeight(modalDom.style.height);
      }

      setStartWidth(modalDom.style.width);
    }

    modalDom.style.height = tempModalMaxHeight;
    modalDom.style.width = tempModalMaxWidth;
    var contentDom = modalDom.getElementsByClassName('ant-modal-content')[0];
    contentDom.style.left = 0 + 'px';
    contentDom.style.top = 0 + 'px';
  };

  var smallScreen = function smallScreen() {
    if (startHeight && startWidth) {
      var modalDom = document.getElementsByClassName(modalClassName)[0];
      modalDom.style.height = startHeight;
      modalDom.style.width = startWidth;
      var contentDom = modalDom.getElementsByClassName('ant-modal-content')[0];
      contentDom.style.left = 0 + 'px';
      contentDom.style.top = 0 + 'px';
    }
  };

  return /*#__PURE__*/React.createElement(Modal, _extends({
    className: [cursorMove ? 'cursorMove' : 'normal', modalClassName, className],
    title: /*#__PURE__*/React.createElement("div", {
      style: {
        width: '100%',
        cursor: cursorMove ? 'move' : 'default'
      }
    }, title, changeSize == true && isDialog == -1 ? /*#__PURE__*/React.createElement("span", {
      style: {
        "float": 'right',
        marginRight: '30px',
        cursor: 'pointer'
      }
    }, /*#__PURE__*/React.createElement("span", {
      onClick: smallScreen,
      style: {
        marginRight: "10px"
      }
    }, /*#__PURE__*/React.createElement("svg", {
      className: "icon",
      viewBox: "0 0 1024 1024",
      version: "1.1",
      xmlns: "http://www.w3.org/2000/svg",
      "p-id": "2866",
      width: "24",
      height: "24"
    }, /*#__PURE__*/React.createElement("path", {
      d: "M133.1 350.25a20 20 0 0 1-20-20V213.36a98 98 0 0 1 97.9-97.93h116.92a20 20 0 0 1 0 40H211a58 58 0 0 0-57.94 57.93v116.89a20 20 0 0 1-19.96 20zM427.51 833.34a20 20 0 0 1-20-20V696.45a57.94 57.94 0 0 0-57.94-57.93H232.69a20 20 0 0 1 0-40h116.88a97.94 97.94 0 0 1 97.94 97.93v116.89a20 20 0 0 1-20 20zM817 444.61H700.07a98.05 98.05 0 0 1-97.94-97.94V229.79a20 20 0 1 1 40 0v116.88a58 58 0 0 0 57.94 57.94H817a20 20 0 0 1 0 40zM826.77 915.19H709.88a20 20 0 0 1 0-40h116.89a58 58 0 0 0 57.93-57.93V700.37a20 20 0 0 1 40 0v116.89a98 98 0 0 1-97.93 97.93z",
      fill: "#292D2D",
      "p-id": "2867"
    }), /*#__PURE__*/React.createElement("path", {
      d: "M133.1 915.15A20 20 0 0 1 118.94 881l241.68-242.4A20 20 0 0 1 389 666.88L147.26 909.27a19.91 19.91 0 0 1-14.16 5.88zM662.31 397.82a20 20 0 0 1-14.15-34.14l242.4-242.4a20 20 0 1 1 28.28 28.29L676.45 392a19.94 19.94 0 0 1-14.14 5.82z",
      fill: "#292D2D",
      "p-id": "2868"
    }))), /*#__PURE__*/React.createElement("span", {
      style: {
        cursor: 'pointer'
      },
      onClick: fullScreen
    }, /*#__PURE__*/React.createElement("svg", {
      className: "icon",
      viewBox: "0 0 1024 1024",
      version: "1.1",
      xmlns: "http://www.w3.org/2000/svg",
      "p-id": "2058",
      width: "24",
      height: "24"
    }, /*#__PURE__*/React.createElement("path", {
      d: "M368.896 192H224a32 32 0 0 0-32 32v137.888a32 32 0 0 0 64 0V256h112.896a32 32 0 0 0 0-64zM784.864 192H640a32 32 0 1 0 0 64h112.864v105.888a32 32 0 1 0 64 0V224a32 32 0 0 0-32-32zM368.896 777.92H256V672a32 32 0 1 0-64 0v137.92a32 32 0 0 0 32 32h144.896a32 32 0 1 0 0-64zM784.864 640a32 32 0 0 0-32 32v105.92H640a32 32 0 1 0 0 64h144.864a32 32 0 0 0 32-32V672a32 32 0 0 0-32-32z",
      "p-id": "2059"
    }), /*#__PURE__*/React.createElement("path", {
      d: "M912 48h-800c-35.296 0-64 28.704-64 64v800c0 35.296 28.704 64 64 64h800c35.296 0 64-28.704 64-64v-800c0-35.296-28.704-64-64-64z m-800 864v-800h800l0.064 800H112z",
      "p-id": "2060"
    })))) : mxModalChangeSize == true && changeSize != false && isDialog == -1 ? /*#__PURE__*/React.createElement("span", {
      style: {
        "float": 'right',
        marginRight: '30px',
        cursor: 'pointer'
      }
    }, /*#__PURE__*/React.createElement("span", {
      onClick: smallScreen,
      style: {
        marginRight: "10px"
      }
    }, /*#__PURE__*/React.createElement("svg", {
      className: "icon",
      viewBox: "0 0 1024 1024",
      version: "1.1",
      xmlns: "http://www.w3.org/2000/svg",
      "p-id": "2866",
      width: "24",
      height: "24"
    }, /*#__PURE__*/React.createElement("path", {
      d: "M133.1 350.25a20 20 0 0 1-20-20V213.36a98 98 0 0 1 97.9-97.93h116.92a20 20 0 0 1 0 40H211a58 58 0 0 0-57.94 57.93v116.89a20 20 0 0 1-19.96 20zM427.51 833.34a20 20 0 0 1-20-20V696.45a57.94 57.94 0 0 0-57.94-57.93H232.69a20 20 0 0 1 0-40h116.88a97.94 97.94 0 0 1 97.94 97.93v116.89a20 20 0 0 1-20 20zM817 444.61H700.07a98.05 98.05 0 0 1-97.94-97.94V229.79a20 20 0 1 1 40 0v116.88a58 58 0 0 0 57.94 57.94H817a20 20 0 0 1 0 40zM826.77 915.19H709.88a20 20 0 0 1 0-40h116.89a58 58 0 0 0 57.93-57.93V700.37a20 20 0 0 1 40 0v116.89a98 98 0 0 1-97.93 97.93z",
      fill: "#292D2D",
      "p-id": "2867"
    }), /*#__PURE__*/React.createElement("path", {
      d: "M133.1 915.15A20 20 0 0 1 118.94 881l241.68-242.4A20 20 0 0 1 389 666.88L147.26 909.27a19.91 19.91 0 0 1-14.16 5.88zM662.31 397.82a20 20 0 0 1-14.15-34.14l242.4-242.4a20 20 0 1 1 28.28 28.29L676.45 392a19.94 19.94 0 0 1-14.14 5.82z",
      fill: "#292D2D",
      "p-id": "2868"
    }))), /*#__PURE__*/React.createElement("span", {
      style: {
        cursor: 'pointer'
      },
      onClick: fullScreen
    }, /*#__PURE__*/React.createElement("svg", {
      className: "icon",
      viewBox: "0 0 1024 1024",
      version: "1.1",
      xmlns: "http://www.w3.org/2000/svg",
      "p-id": "2058",
      width: "24",
      height: "24"
    }, /*#__PURE__*/React.createElement("path", {
      d: "M368.896 192H224a32 32 0 0 0-32 32v137.888a32 32 0 0 0 64 0V256h112.896a32 32 0 0 0 0-64zM784.864 192H640a32 32 0 1 0 0 64h112.864v105.888a32 32 0 1 0 64 0V224a32 32 0 0 0-32-32zM368.896 777.92H256V672a32 32 0 1 0-64 0v137.92a32 32 0 0 0 32 32h144.896a32 32 0 1 0 0-64zM784.864 640a32 32 0 0 0-32 32v105.92H640a32 32 0 1 0 0 64h144.864a32 32 0 0 0 32-32V672a32 32 0 0 0-32-32z",
      "p-id": "2059"
    }), /*#__PURE__*/React.createElement("path", {
      d: "M912 48h-800c-35.296 0-64 28.704-64 64v800c0 35.296 28.704 64 64 64h800c35.296 0 64-28.704 64-64v-800c0-35.296-28.704-64-64-64z m-800 864v-800h800l0.064 800H112z",
      "p-id": "2060"
    })))) : null)
  }, rest));
}