"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = DatePickerFormat;

var _react = _interopRequireWildcard(require("react"));

var _moment = _interopRequireDefault(require("moment"));

var _datepicker = _interopRequireDefault(require("../datepicker"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var changeValueFormat = function changeValueFormat(value, sourceMask) {
  if (!value) {
    return null;
  }

  if (value instanceof Date) {
    return (0, _moment["default"])(value);
  } else if (_moment["default"].isMoment(value)) {
    return value;
  } else if (typeof value === "string" || typeof value === "number") {
    if (!sourceMask) {
      throw new Error("DatePickerAdapter \u6536\u5230 value: '".concat(value, "', type: '").concat(_typeof(value), "'\uFF0C\u4F46\u6CA1\u5199 sourceMask\uFF0C\u8BF7\u68C0\u67E5!"));
    }

    var strValue = String(value);
    var mnt = (0, _moment["default"])(strValue, sourceMask, true);

    if (!mnt.isValid()) {
      throw new Error("DatePickerAdapter \u6536\u5230 value: '".concat(value, "', type: '").concat(_typeof(value), "'\uFF0C\u4E0E sourceMask: '").concat(sourceMask, "' \u683C\u5F0F\u4E0D\u5339\u914D\uFF0C\u8BF7\u68C0\u67E5!"));
    }

    return mnt;
  }
};

function DatePickerFormat(props) {
  var value = props.value,
      children = props.children,
      onChange = props.onChange,
      sourceMask = props.sourceMask,
      targetMask = props.targetMask;

  var _useState = (0, _react.useState)(sourceMask),
      _useState2 = _slicedToArray(_useState, 2),
      DatePickerFormat = _useState2[0],
      updateDatePickerFormat = _useState2[1];

  var data = changeValueFormat(value, sourceMask);

  var inputFocus = function inputFocus() {
    updateDatePickerFormat(sourceMask);
  };

  var inputBlur = function inputBlur() {
    updateDatePickerFormat(targetMask);
  };

  var triggerOnChange = function triggerOnChange(date, datestring) {
    if (onChange) {
      onChange(date, datestring);
    }

    if (children.props.onChange) {
      children.props.onChange(date, datestring);
    }
  };

  return /*#__PURE__*/_react["default"].createElement(_datepicker["default"], _extends({}, children.props, {
    value: data,
    onChange: triggerOnChange,
    onFocus: inputFocus,
    onBlur: inputBlur,
    format: DatePickerFormat
  }));
}