"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _modal = _interopRequireDefault(require("../modal"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var __awaiter = void 0 && (void 0).__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

var DEFAULT_DIALOG_CONFIG = {
  title: '对话框',
  width: 520,
  height: 'auto',
  props: {},
  closable: true
};

var Dialog = /*#__PURE__*/function (_React$Component) {
  _inherits(Dialog, _React$Component);

  var _super = _createSuper(Dialog);

  function Dialog(props) {
    var _this;

    _classCallCheck(this, Dialog);

    _this = _super.call(this, props);

    _this.closeDialog = function (params) {
      return __awaiter(_assertThisInitialized(_this), void 0, void 0, /*#__PURE__*/_regenerator["default"].mark(function _callee() {
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(this.componentRef.current && this.componentRef.current.beforeClose)) {
                  _context.next = 3;
                  break;
                }

                _context.next = 3;
                return this.componentRef.current.beforeClose();

              case 3:
                this.setState({
                  visible: false,
                  // @ts-ignore
                  component: null,
                  config: DEFAULT_DIALOG_CONFIG
                });
                this.promiseResolver(params);
                this.promiseResolver = null;

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));
    };

    _this.openDialog = function (Component) {
      var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : DEFAULT_DIALOG_CONFIG;
      return __awaiter(_assertThisInitialized(_this), void 0, void 0, /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
        var _this2 = this;

        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!this.promiseResolver) {
                  _context2.next = 2;
                  break;
                }

                throw new Error('Dialog一次只能弹出一个，检查检查程序呗？');

              case 2:
                this.setState({
                  visible: true,
                  component: Component,
                  config: config
                });
                return _context2.abrupt("return", new Promise(function (resolve) {
                  _this2.promiseResolver = resolve;
                }));

              case 4:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));
    };

    _this.state = {
      visible: false,
      // @ts-ignore
      component: null,
      config: DEFAULT_DIALOG_CONFIG
    };
    _this.promiseResolver = null;
    _this.componentRef = /*#__PURE__*/_react["default"].createRef();
    return _this;
  }

  _createClass(Dialog, [{
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$state = this.state,
          visible = _this$state.visible,
          Component = _this$state.component,
          config = _this$state.config;
      var title = config.title,
          width = config.width,
          _config$height = config.height,
          height = _config$height === void 0 ? 'auto' : _config$height,
          componentProps = config.props,
          closable = config.closable;
      var clzName = (0, _classnames["default"])('mousex-dialog', {
        'mousex-dialog-height_auto': height === 'auto',
        'mousex-dialog-height_fixed': height !== 'auto'
      });
      var cssStyle = {};

      if (height !== 'auto') {
        cssStyle = _extends(_extends({}, cssStyle), {
          height: height
        });
      }

      return /*#__PURE__*/_react["default"].createElement(_modal["default"], {
        className: clzName,
        style: cssStyle,
        title: title,
        width: width,
        visible: visible,
        onCancel: function onCancel() {
          return _this3.closeDialog();
        },
        footer: null,
        centered: true,
        maskClosable: false,
        closable: closable,
        destroyOnClose: true
      }, Component && /*#__PURE__*/_react["default"].createElement(Component, _extends({}, componentProps, {
        closeDialog: this.closeDialog,
        ref: this.componentRef
      })));
    }
  }]);

  return Dialog;
}(_react["default"].Component);

exports["default"] = Dialog;