"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = MXConfigProvider;

var _react = _interopRequireWildcard(require("react"));

var _MouseXConfigContext = _interopRequireDefault(require("./MouseXConfigContext"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function MXConfigProvider(props) {
  var mxColumnConfig, mxInputShowTitle, mxTableRowSelectedCss, mxTableRowOnClickCss, mxTabsMode, mxInputNumberAutoFillout, mxModalDraggable, mxModalChangeSize, mxModalMaxWidth, mxModalMaxHeight, mxButtonNeedThrottle, mxButtonThrottleTime, mxButtonThrottleIsImmediate;
  var children = props.children,
      numberColumnConfig = props.numberColumnConfig,
      inputShowTitle = props.inputShowTitle,
      tableRowSelectedCss = props.tableRowSelectedCss,
      tableRowOnClickCss = props.tableRowOnClickCss,
      tabsMode = props.tabsMode,
      modalDraggable = props.modalDraggable,
      inputNumberAutoFillout = props.inputNumberAutoFillout,
      modalChangeSize = props.modalChangeSize,
      modalMaxWidth = props.modalMaxWidth,
      modalMaxHeight = props.modalMaxHeight,
      buttonNeedThrottle = props.buttonNeedThrottle,
      buttonThrottleTime = props.buttonThrottleTime,
      buttonThrottleIsImmediate = props.buttonThrottleIsImmediate;
  var mxConfigContext = (0, _react.useContext)(_MouseXConfigContext["default"]);

  if (numberColumnConfig) {
    mxColumnConfig = _extends({}, numberColumnConfig);
    if (!numberColumnConfig.numberTitle) mxColumnConfig = _extends(_extends({}, mxColumnConfig), {
      numberTitle: mxConfigContext.numberColumnConfig.numberTitle
    });
    if (!numberColumnConfig.numberWidth) mxColumnConfig = _extends(_extends({}, mxColumnConfig), {
      numberWidth: mxConfigContext.numberColumnConfig.numberWidth
    });
    if (!numberColumnConfig.dataIndex) mxColumnConfig = _extends(_extends({}, mxColumnConfig), {
      dataIndex: mxConfigContext.numberColumnConfig.dataIndex
    });
    if (!numberColumnConfig.align) mxColumnConfig = _extends(_extends({}, mxColumnConfig), {
      align: mxConfigContext.numberColumnConfig.align
    });
    if (!numberColumnConfig.fixed) mxColumnConfig = _extends(_extends({}, mxColumnConfig), {
      fixed: mxConfigContext.numberColumnConfig.fixed
    });
  }

  if (inputShowTitle) {
    mxInputShowTitle = inputShowTitle;
  } else {
    mxInputShowTitle = mxConfigContext.inputShowTitle;
  }

  if (tableRowSelectedCss) {
    mxTableRowSelectedCss = tableRowSelectedCss;
  } else {
    mxTableRowSelectedCss = mxConfigContext.tableRowSelectedCss;
  }

  if (tableRowOnClickCss) {
    mxTableRowOnClickCss = tableRowOnClickCss;
  } else {
    mxTableRowOnClickCss = mxConfigContext.tableRowOnClickCss;
  }

  if (tabsMode) {
    mxTabsMode = tabsMode;
  } else {
    mxTabsMode = mxConfigContext.tabsMode;
  }

  if (modalDraggable) {
    mxModalDraggable = modalDraggable;
  } else {
    mxModalDraggable = mxConfigContext.modalDraggable;
  }

  if (modalChangeSize) {
    mxModalChangeSize = modalChangeSize;
  } else {
    mxModalChangeSize = mxConfigContext.modalChangeSize;
  }

  if (modalMaxWidth) {
    mxModalMaxWidth = modalMaxWidth;
  } else {
    mxModalMaxWidth = mxConfigContext.modalMaxWidth;
  }

  if (modalMaxHeight) {
    mxModalMaxHeight = modalMaxHeight;
  } else {
    mxModalMaxHeight = mxConfigContext.modalMaxHeight;
  }

  if (inputNumberAutoFillout) {
    mxInputNumberAutoFillout = inputNumberAutoFillout;
  } else {
    mxInputNumberAutoFillout = mxConfigContext.inputNumberAutoFillout;
  }

  if (buttonNeedThrottle != undefined) {
    mxButtonNeedThrottle = buttonNeedThrottle;
  } else {
    mxButtonNeedThrottle = mxConfigContext.buttonNeedThrottle;
  }

  if (buttonThrottleTime) {
    mxButtonThrottleTime = buttonThrottleTime;
  } else {
    mxButtonThrottleTime = mxConfigContext.buttonThrottleTime;
  }

  if (buttonThrottleIsImmediate != undefined) {
    mxButtonThrottleIsImmediate = buttonThrottleIsImmediate;
  } else {
    mxButtonThrottleIsImmediate = mxConfigContext.buttonThrottleIsImmediate;
  }

  return /*#__PURE__*/_react["default"].createElement(_MouseXConfigContext["default"].Provider, {
    value: {
      numberColumnConfig: mxColumnConfig,
      inputShowTitle: mxInputShowTitle,
      tableRowSelectedCss: mxTableRowSelectedCss,
      tableRowOnClickCss: mxTableRowOnClickCss,
      tabsMode: mxTabsMode,
      modalDraggable: mxModalDraggable,
      modalChangeSize: mxModalChangeSize,
      modalMaxWidth: mxModalMaxWidth,
      modalMaxHeight: mxModalMaxHeight,
      inputNumberAutoFillout: mxInputNumberAutoFillout,
      buttonNeedThrottle: mxButtonNeedThrottle,
      buttonThrottleTime: mxButtonThrottleTime,
      buttonThrottleIsImmediate: mxButtonThrottleIsImmediate
    }
  }, children);
}