"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = MyButton;

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _MouseXConfigContext = _interopRequireDefault(require("../MXConfigProvider/MouseXConfigContext"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

function MyButton(props) {
  var needThrottle = props.needThrottle,
      throttleTime = props.throttleTime,
      throttleIsImmediate = props.throttleIsImmediate,
      onClick = props.onClick,
      restProps = __rest(props, ["needThrottle", "throttleTime", "throttleIsImmediate", "onClick"]);

  var mxConfigContext = (0, _react.useContext)(_MouseXConfigContext["default"]);

  function throttle(fn, delay) {
    var valid = true;
    return function () {
      //休息时间 不允许执行
      if (!valid) {
        return false;
      } // 工作时间，执行函数并且在间隔期内把状态位设为无效


      valid = false;
      tempThrottleIsImmediate && fn();
      setTimeout(function () {
        !tempThrottleIsImmediate && fn();
        valid = true;
      }, delay);
    };
  }

  var _useState = (0, _react.useState)(true),
      _useState2 = _slicedToArray(_useState, 2),
      flag = _useState2[0],
      setFlag = _useState2[1];

  var tempThrottleTime;
  var tempThrottleIsImmediate;

  if (mxConfigContext.buttonThrottleTime) {
    if (throttleTime) {
      tempThrottleTime = throttleTime;
    } else {
      tempThrottleTime = mxConfigContext.buttonThrottleTime;
    }
  } else {
    if (throttleTime) {
      tempThrottleTime = throttleTime;
    } else {
      tempThrottleTime = 1000;
    }
  }

  if (mxConfigContext.buttonThrottleIsImmediate) {
    if (throttleIsImmediate) {
      tempThrottleIsImmediate = throttleIsImmediate;
    } else {
      tempThrottleIsImmediate = mxConfigContext.buttonThrottleIsImmediate;
    }
  } else {
    if (throttleIsImmediate == true || throttleIsImmediate == false) {
      tempThrottleIsImmediate = throttleIsImmediate;
    } else {
      tempThrottleIsImmediate = true;
    }
  }

  (0, _react.useEffect)(function () {
    if (mxConfigContext.buttonNeedThrottle) {
      if (needThrottle) {
        setFlag(true);
      } else if (needThrottle == false) {
        setFlag(false);
      } else {
        setFlag(true);
      }
    } else {
      if (needThrottle) {
        setFlag(true);
      } else if (needThrottle == false) {
        setFlag(false);
      } else {
        setFlag(false);
      }
    }
  }, []);
  return /*#__PURE__*/_react["default"].createElement(_antd.Button, _extends({
    onClick: flag ? throttle(onClick, tempThrottleTime) : onClick
  }, restProps));
}