"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _datePicker = _interopRequireDefault(require("./date-picker"));

var _moment = _interopRequireDefault(require("moment"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
}; // @ts-nocheck


var changeValueFormat = function changeValueFormat(value, mask1, mask2) {
  if (!value) {
    return null;
  }

  if (value instanceof Date) {
    return (0, _moment["default"])(value);
  } else if (_moment["default"].isMoment(value)) {
    return value;
  } else if (typeof value === "string" || typeof value === "number") {
    if (!mask1) {
      throw new Error("DatePickerAdapter \u6536\u5230 value: '".concat(value, "', type: '").concat(_typeof(value), "'\uFF0C\u4F46\u6CA1\u5199 targetMask\uFF0C\u8BF7\u68C0\u67E5!"));
    }

    var strValue = String(value);
    var mnt = (0, _moment["default"])(strValue, [mask1, mask2], true);

    if (!mnt.isValid()) {
      throw new Error("DatePickerAdapter \u6536\u5230 value: '".concat(value, "', type: '").concat(_typeof(value), "'\uFF0C\u4E0E targetMask: '").concat(mask1, "' \u683C\u5F0F\u4E0D\u5339\u914D\uFF0C\u8BF7\u68C0\u67E5!"));
    }

    return mnt;
  }
};

var getFormat = function getFormat(format, picker) {
  if (format) {
    return format;
  } else {
    if (picker == 'month') {
      return 'YYYY-MM';
    } else if (picker == 'week') {
      return 'YYYY-wo';
    } else if (picker == 'quarter') {
      return 'YYYY-\\QQ';
    } else if (picker == 'year') {
      return 'YYYY';
    } else {
      return 'YYYY-MM-DD';
    }
  }
}; // 仅需要展示数据的格式，通过正则表达式支持无符号输入 format ， format.replace(/[^a-zA-Z]/g,'')


var MyDatePicker = function MyDatePicker(props, ref) {
  var id = props.id,
      value = props.value,
      onChange = props.onChange,
      format = props.format,
      showTime = props.showTime,
      picker = props.picker,
      _onBlur = props.onBlur,
      _onFocus = props.onFocus,
      autoFillFirstday = props.autoFillFirstday,
      restprops = __rest(props, ["id", "value", "onChange", "format", "showTime", "picker", "onBlur", "onFocus", "autoFillFirstday"]);

  var targetFormat = getFormat(format, picker);

  var _useState = (0, _react.useState)(targetFormat),
      _useState2 = _slicedToArray(_useState, 2),
      DatePickerFormat = _useState2[0],
      updateDatePickerFormat = _useState2[1];

  var _useState3 = (0, _react.useState)(changeValueFormat(value, targetFormat, targetFormat.replace(/[^a-zA-Z]/g, ''))),
      _useState4 = _slicedToArray(_useState3, 2),
      data = _useState4[0],
      setData = _useState4[1];

  var inputFocus = function inputFocus() {
    // 聚焦 ： 传入数据格式
    updateDatePickerFormat([targetFormat, targetFormat.replace(/[^a-zA-Z]/g, '')]);
  };

  var inputBlur = function inputBlur() {
    var datepickerID = document.getElementById('datepicker' + id);

    if (autoFillFirstday === true && datepickerID && datepickerID.value.length === 6) {
      setData(changeValueFormat((0, _moment["default"])(datepickerID.value + '01'), targetFormat, targetFormat.replace(/[^a-zA-Z]/g, '')));
      onChange((0, _moment["default"])(datepickerID.value + '01'), datepickerID.value + '01');
    } // 失焦 ： 展示数据格式


    updateDatePickerFormat(targetFormat);
  };

  var triggerOnChange = function triggerOnChange(date, datestring) {
    var datepickerID = document.getElementById('datepicker' + id);

    if (autoFillFirstday === true && datepickerID && datepickerID.value.length === 6) {
      setData(changeValueFormat((0, _moment["default"])(datepickerID.value + '01'), targetFormat, targetFormat.replace(/[^a-zA-Z]/g, '')));
      onChange((0, _moment["default"])(datepickerID.value + '01'), datepickerID.value + '01');
    } else {
      setData(date);
      onChange(date, datestring);
    }
  };

  if (showTime === true) {
    return /*#__PURE__*/_react["default"].createElement(_datePicker["default"], _extends({
      ref: ref
    }, props));
  } else {
    if (autoFillFirstday === true) {
      return /*#__PURE__*/_react["default"].createElement(_datePicker["default"], _extends({
        id: 'datepicker' + id
      }, restprops, {
        picker: picker,
        ref: ref,
        value: data,
        onChange: triggerOnChange,
        onFocus: function onFocus() {
          _onFocus ? _onFocus() : null;
          inputFocus();
        },
        onBlur: function onBlur(e) {
          inputBlur();
          _onBlur ? _onBlur(e) : null;
        },
        format: DatePickerFormat,
        placeholder: '请选择日期'
      }));
    } else return /*#__PURE__*/_react["default"].createElement(_datePicker["default"], _extends({}, restprops, {
      picker: picker,
      ref: ref,
      value: data,
      onChange: triggerOnChange,
      onFocus: function onFocus() {
        _onFocus ? _onFocus() : null;
        inputFocus();
      },
      onBlur: function onBlur(e) {
        inputBlur();
        _onBlur ? _onBlur(e) : null;
      },
      format: DatePickerFormat
    }));
  }
};

var _default = /*#__PURE__*/(0, _react.forwardRef)(MyDatePicker);

exports["default"] = _default;